OpenTTD Source: GroupStatistics Struct Reference

OpenTTD Source 13.2.1

Public Member Functions | Static Public Member Functions | Data Fields
GroupStatistics Struct Reference

Statistics and caches on the vehicles in a group. More...

`#include <group.h>`

## Public Member Functions
void | Clear ()
| Clear all caches.
void | ClearProfits ()
void | ClearAutoreplace ()

## Static Public Member Functions
static GroupStatistics & | Get (CompanyID company, GroupID id_g, VehicleType type)
| Returns the GroupStatistics for a specific group. More...
static GroupStatistics & | Get (const Vehicle *v)
| Returns the GroupStatistic for the group of a vehicle. More...
static GroupStatistics & | GetAllGroup (const Vehicle *v)
| Returns the GroupStatistic for the ALL_GROUPO of a vehicle type. More...
static void | CountVehicle (const Vehicle *v, int delta)
| Update num_vehicle when adding or removing a vehicle. More...
static void | CountEngine (const Vehicle *v, int delta)
| Update num_engines when adding/removing an engine. More...
static void | AddProfitLastYear (const Vehicle *v)
| Add a vehicle's last year profit to the profit sum of its group.
static void | VehicleReachedMinAge (const Vehicle *v)
| Add a vehicle to the profit sum of its group.
static void | UpdateProfits ()
| Recompute the profits for all groups.
static void | UpdateAfterLoad ()
| Update all caches after loading a game, changing NewGRF, etc.
static void | UpdateAutoreplace (CompanyID company)
| Update autoreplace_defined and autoreplace_finished of all statistics of a company. More...

## Data Fields
Money | profit_last_year
| Sum of profits for all vehicles.
Money | profit_last_year_min_age
| Sum of profits for vehicles considered for profit statistics.
uint16 * | num_engines
| Caches the number of engines of each type the company owns.
uint16 | num_vehicle
| Number of vehicles.
uint16 | num_vehicle_min_age
| Number of vehicles considered for profit statistics;.
bool | autoreplace_defined
| Are any autoreplace rules set?
bool | autoreplace_finished
| Have all autoreplacement finished?

## Detailed Description

Statistics and caches on the vehicles in a group.

Definition at line 25 of file group.h.

## Member Function Documentation

## ◆ CountEngine()

void GroupStatistics::CountEngine | ( | const Vehicle * | v,
|  | int | delta
| ) |  |
| static

Update num_engines when adding/removing an engine.

Parameters

  v | Engine to count.
  delta | +1 to add, -1 to remove.

Definition at line 157 of file group_cmd.cpp.

References Vehicle::engine_type, Get(), GetAllGroup(), and num_engines.

## ◆ CountVehicle()

void GroupStatistics::CountVehicle | ( | const Vehicle * | v,
|  | int | delta
| ) |  |
| static

Update num_vehicle when adding or removing a vehicle.

Parameters

  v | Vehicle to count.
  delta | +1 to add, -1 to remove.

Definition at line 132 of file group_cmd.cpp.

References Vehicle::age, Get(), GetAllGroup(), Vehicle::GetDisplayProfitLastYear(), num_vehicle, num_vehicle_min_age, profit_last_year, profit_last_year_min_age, and VEHICLE_PROFIT_MIN_AGE.

Referenced by AddVehicleToGroup(), and CmdSellRailWagon().

## ◆ Get() [1/2]

GroupStatistics & GroupStatistics::Get | ( | CompanyID | company,
|  | GroupID | id_g,
|  | VehicleType | type
| ) |  |
| static

Returns the GroupStatistics for a specific group.

Parameters

  company | Owner of the group.
  id_g | GroupID of the group.
  type | VehicleType of the vehicles in the group.

Returns
  Statistics for the group.

Definition at line 62 of file group_cmd.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_group_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_group_pool >::IsValidID(), Group::owner, Group::statistics, and Group::vehicle_type.

Referenced by AddProfitLastYear(), CountEngine(), CountVehicle(), Get(), GetAllGroup(), GetGroupNumEngines(), GetGroupNumVehicle(), GetGroupNumVehicleMinAge(), GetGroupProfitLastYearMinAge(), UpdateNumEngineGroup(), and VehicleReachedMinAge().

## ◆ Get() [2/2]

GroupStatistics & GroupStatistics::Get | ( | const Vehicle * | v | ) |
| static

Returns the GroupStatistic for the group of a vehicle.

Parameters

  v | Vehicle.

Returns
  GroupStatistics for the group of the vehicle.

Definition at line 82 of file group_cmd.cpp.

References Get(), Vehicle::group_id, Vehicle::owner, and BaseVehicle::type.

## ◆ GetAllGroup()

GroupStatistics & GroupStatistics::GetAllGroup | ( | const Vehicle * | v | ) |
| static

Returns the GroupStatistic for the ALL_GROUPO of a vehicle type.

Parameters

  v | Vehicle.

Returns
  GroupStatistics for the ALL_GROUP of the vehicle type.

Definition at line 92 of file group_cmd.cpp.

References ALL_GROUP, Get(), Vehicle::owner, and BaseVehicle::type.

Referenced by AddProfitLastYear(), CountEngine(), CountVehicle(), and VehicleReachedMinAge().

## ◆ UpdateAutoreplace()

void GroupStatistics::UpdateAutoreplace | ( | CompanyID | company | ) |
| static

Update autoreplace_defined and autoreplace_finished of all statistics of a company.

Parameters

  company | Company to update statistics for.

Definition at line 220 of file group_cmd.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::Get().

Referenced by CmdAlterGroup().

The documentation for this struct was generated from the following files:

- src/group.h
- src/group_cmd.cpp